/* Poorly written enemy class, might have to rewrite it from scratch.
 * Written by M.Narvidas
 * 
 * 
 * 2012
 */

class Enemy {
  PVector position,velocity; // PVector containing X and Y
  float speed = 5; // Speed the enemy moves
  
  Enemy() { // Constructor
    position = new PVector();
    velocity = new PVector();
    reset();
  }
  
  void reset() { //put the enemy back in it's original position
    velocity.x = 0;
    velocity.y = 0;
  }
  
  void checkEnemy(){ //This method adds velocity and calls further checks
    position.add(velocity);
    checkForWallBumpingEnemy();
  }
  
  void checkForWallBumpingEnemy() {
    int enemyWidth = enemy.width; // get the size of the sprite
    int enemyHeight = enemy.height;
    int probeDistance = int(enemyWidth*0.3); // probe distancte to check collisions. A third of the sprite width is used here.

    
    //Probes
    PVector leftSideHigh,rightSideHigh;
    leftSideHigh = new PVector();
    rightSideHigh = new PVector();

    // Update the probes
    leftSideHigh.x = position.x - probeDistance; // left edge of enemy
    leftSideHigh.y = position.y;
    rightSideHigh.x = position.x + probeDistance; // right edge of enemy
    rightSideHigh.y = position.y;

   
    if( theWorld.worldSquareAt(rightSideHigh)==theWorld.TILE_SOLID || theWorld.worldSquareAt(rightSideHigh)==theWorld.TILE_GRASS ) { // if right side collides with a wall then flip it
        enemyFlip = !enemyFlip;
    }


    if( theWorld.worldSquareAt(leftSideHigh)==theWorld.TILE_SOLID || theWorld.worldSquareAt(leftSideHigh)==theWorld.TILE_GRASS ) { // if left side collides with a wall then flip it
       enemyFlip = !enemyFlip;
    }
  }
  
  
  void draw() {
    int enemyWidth = enemy.width;
    int enemyHeight = enemy.height;
    
    pushMatrix(); // Allows transformations
    
    translate(position.x,position.y);
    if(enemyFlip == true) { //if we have to flip the enemy then invert the speed
      velocity.x = - speed;
      scale(-1,1); // Scale the image horizontally by -1
    }
   else if(enemyFlip == false) {
      velocity.x = speed;
   }
   
   translate(-enemyWidth/2,-enemyHeight); // Draw enemy in the centre of the object coordinates

   image(enemy, 0,0);

   popMatrix(); // Undoes all the transformation calls
  }
}

