
void checkAll(float tx, float ty) {
  if (tx > lx && tx < lx + arrowW && ty > ly && ty < ly + arrowH) { //if button "left" is pressed
    leftPressed = true;
  }
  if (tx > rx && tx < rx + arrowW && ty > ry && ty < ry + arrowH) { //if right button is pressed
    rightPressed = true;
  }
  if (tx > ux && tx < ux + arrowW && ty > uy && ty < uy + arrowH) { //if  up button is pressed
    upPressed = true;
  }
}

void releaseAll(float tx, float ty) {
  if (tx > lx && tx < lx + arrowW && ty > ly && ty < ly + arrowH) {   //if button "left" is released
    leftPressed = false;
  }
  if (tx > rx && tx < rx + arrowW && ty > ry && ty < ry + arrowH) {  //if right button is released
    rightPressed = false;
  }
  if (tx > ux && tx < ux + arrowW && ty > uy && ty < uy + arrowH) { //if button "up" is released
    upPressed = false;
  }
}


public boolean surfaceTouchEvent(MotionEvent me) {

  //Pointer number
  int numPointers = me.getPointerCount();
  //Pressed or released. Can be many more though
  final int action = me.getAction() & MotionEvent.ACTION_MASK;

  //get the pointer index for this action
  //ACTION_POINTER_ID_SHIFT actually returns the INDEX not the id. This made me pull my hair out
  int pointerIndex = (me.getAction() & MotionEvent.ACTION_POINTER_ID_MASK)
    >> MotionEvent.ACTION_POINTER_ID_SHIFT; //Right shift
  //Gets pointer ID
  int pointerId = me.getPointerId(pointerIndex);

  {
      
  if (action == MotionEvent.ACTION_POINTER_DOWN || action == MotionEvent.ACTION_DOWN){  //If finger is pressed ==> action down  
    hasrun = false;
    
    for (int i = 0; i<numPointers;i++)
    {
      int newId = me.getPointerId(i);

      if (pointerId == 0)
      {
        checkX0 = me.getX(i);
        checkY0 = me.getY(i);
        println("1st:"+checkX0+checkY0);
        checkAll(checkX0, checkY0);
      }
      else
        if (pointerId == 1 && hasrun == false)
        {
          checkTX1 = me.getX(i);
          checkTY1 = me.getY(i);
          println("2nd:"+checkX1+checkY1);
          //checkAll(checkX1, checkY1);
          hasrun = true;
        }
       else
        if (pointerId == 1)
        {
          checkX1 = me.getX(i);
          checkY1 = me.getY(i);
          if (!((checkTX1 == checkX1) && (checkTY1 == checkY1))){  //fix for stuck buttons. not 100%. still get's stuck sometimes
          println("2nd:"+checkX1+checkY1);
          checkAll(checkX1, checkY1);
        }
        }
        else
          if (pointerId == 2)
          {
            // probably for bullets or something
          }
    }
  } 
  else
    //If finger is released ==> action up
    if (action == MotionEvent.ACTION_UP || action == MotionEvent.ACTION_POINTER_UP)
    {
      for (int i = 0; i<numPointers;i++)
      {
        int newId = me.getPointerId(i);

        if (pointerId == 0)
        {
         // println("1st released"); //debug
          releaseAll(checkX0, checkY0);
        }
        else
          if (pointerId == 1)
          {
         //   println("2nd released"); //debug
            releaseAll(checkX1, checkY1);
          }
          else
            if (pointerId == 2)
            {
              
            }
      }
    }
 if(action == MotionEvent.ACTION_MOVE)
  {
    
    for(int i = 0; i<numPointers;i++)
    {
      int newId = me.getPointerId(i);
              

//you can get x,y positions with me.getX(i), me.getY(i)

      if(newId == 0)
      {
             
        //       releaseAllMove(me.getX(i), me.getY(i));
      }
      else
      if(newId == 1)
      {
          //     releaseAllMove(me.getX(i), me.getY(i));
      }
      else
      if(newId == 2)
      {
           //    releaseAllMove(me.getX(i), me.getY(i));
      }
    }

 }
  

  return super.surfaceTouchEvent(me); //processing wiki says this has to be called in order to process touches correctly
}
  }

void drawArrows() { //draw the buttons on the screen
  if (upPressed) { 
    image(arrowUPP, arrowUp.x, arrowUp.y);
  } 
  else if (upPressed == false) { 
    image(arrowUPN, arrowUp.x, arrowUp.y);
  }
  if (rightPressed) {
    image(arrowP, arrowLeft.x, arrowLeft.y);
  } 
  else if (rightPressed == false) {
    image(arrowN, arrowLeft.x, arrowLeft.y);
  }
  translate(arrowRight.x-160, arrowRight.y);
  scale(-1, 1); // flip horizontally scalling by -1
  if (leftPressed) {
    image(arrowP, 0, 0);
  } 
  else if (leftPressed == false) {
    image(arrowN, 0, 0);
  }
}

